/*
 *  Copyright (c) 2000-2003 Yale University. All rights reserved.
 *
 *  THIS SOFTWARE IS PROVIDED "AS IS," AND ANY EXPRESS OR IMPLIED
 *  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, ARE EXPRESSLY
 *  DISCLAIMED. IN NO EVENT SHALL YALE UNIVERSITY OR ITS EMPLOYEES BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED, THE COSTS OF
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH
 *  DAMAGE.
 *
 *  Redistribution and use of this software in source or binary forms,
 *  with or without modification, are permitted, provided that the
 *  following conditions are met:
 *
 *  1. Any redistribution must include the above copyright notice and
 *  disclaimer and this list of conditions in any related documentation
 *  and, if feasible, in the redistributed software.
 *
 *  2. Any redistribution must include the acknowledgment, "This product
 *  includes software developed by Yale University," in any related
 *  documentation and, if feasible, in the redistributed software.
 *
 *  3. The names "Yale" and "Yale University" must not be used to endorse
 *  or promote products derived from this software.
 */

/* $Id: cas.h,v 1.6 2006-04-08 15:14:04+09 naito Exp root $ */

/* CAS information */

#define DEFAULT_CASLocalCacheFile NULL
#define DEFAULT_CASLocalCacheSize 1000
#define DEFAULT_CASLocalCacheTimeout 3600
#define DEFAULT_CASLocalCacheInsecure 0
#define DEFAULT_CASLogoutParameter NULL
#define DEFAULT_CASLogoutLocalURL NULL

#define DEFAULT_CASHost		"srvlet.math.nagoya-u.ac.jp"
#define DEFAULT_CASPort		"80"
#define DEFAULT_CASValidatePort	"80"
#define DEFAULT_CASMethod	"GET"
#define DEFAULT_CASLogin	"/cas/login"
#define DEFAULT_CASLogout	"/cas/logout"
#define DEFAULT_CASValidate	"/cas/validate"
#define DEFAULT_CASGoback	"/cas/backService.jsp"
#define DEFAULT_CASMatchValidUser "uid"
#define DEFAULT_CASLoginSSL	0
#define DEFAULT_CASLogoutSSL	0
#define DEFAULT_CASValidateSSL	0
#define DEFAULT_CASGobackSSL	0
#define DEFAULT_CASDEBUG	0
#define DEFAULT_CASProtocol	"HTTP/1.1"
#define DEFAULT_CASLOGFILE      "/tmp/mod_cas2.log"

#define BAD_CERT -12

/* our "configuration record" */
typedef struct {
  char *CASLocalCacheFile;
  char *CASLogoutParameter;
  char *CASLogoutLocalURL;
  char *CASEGDFile;
  int CASLocalCacheSize;
  time_t CASLocalCacheTimeout;
  char CASLocalCacheInsecure;
  int  CASLoginSSL;
  int  CASLogoutSSL;
  int  CASValidateSSL;
  int  CASGobackSSL;
  int  CASDEBUG;
  char *CASHost;
  char *CASPort;
  char *CASValidatePort;
  char *CASMethod;
  char *CASLogin;
  char *CASLogout;
  char *CASValidate;
  char *CASGoback;
  char *CASProtocol;
  char **CASTrustedCA ;
  char **CASTrustedCADir ;
  char *CASMatchValidUser ;
  char *CASLOGFILE ;
} mod_cas2_conf;


#define LOG(X) log(X) 

#define BUFLEN	(100000) 
/*  #define	BUFLEN	(16384) */

#define	CAS_FAIL_INVALID_SERVICE	(2)
#define	CAS_FAIL_INVALID_TICKET		(3)
#define	CAS_FAIL_ACCESS_DENIED		(4)
#define	CAS_FAIL_OTHER			(5)
#define	CAS_SUCCESS			(1) 


int cas_debug ;
char *cas_logfile ;
