/* $Id: cas_init.c,v 1.7 2006-04-08 15:14:40+09 naito Exp root $ */

static const char *read_CASMatchValidUser(
	cmd_parms *cmd, void *dummy, char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASMatchValidUser = (char *)word ;
    return NULL;
}

static const char *read_CASLoginSSL(
	cmd_parms *cmd, void *dummy, int bool) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLoginSSL = (!(!bool));
    return NULL;
}

static const char *read_CASLogoutSSL(
	cmd_parms *cmd, void *dummy, int bool) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLogoutSSL = (!(!bool));
    return NULL;
}

static const char *read_CASValidateSSL(
	cmd_parms *cmd, void *dummy, int bool) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASValidateSSL = (!(!bool));
    return NULL;
}

static const char *read_CASGobackSSL(
	cmd_parms *cmd, void *dummy, int bool) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASGobackSSL = (!(!bool));
    return NULL;
}

static const char *read_CASHost(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASHost = (char *) word;
    return NULL;
}

static const char *read_CASPort(
	cmd_parms *cmd, void *dummy, const char *word) {
  mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASPort = (char *) word;
    return NULL;
}

static const char *read_CASValidatePort(
	cmd_parms *cmd, void *dummy, const char *word) {
  mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASValidatePort = (char *) word;
    return NULL;
}

static const char *read_CASMethod(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASMethod = (char *) word;
    return NULL;
}

static const char *read_CASLogin(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLogin = (char *) word;
    return NULL;
}

static const char *read_CASLogout(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLogout = (char *) word;
    return NULL;
}

static const char *read_CASValidate(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASValidate = (char *) word;
    return NULL;
}

static const char *read_CASGoback(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASGoback = (char *) word;
    return NULL;
}

static const char *read_CASProtocol(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASProtocol = (char *) word;
    return NULL;
}

/*
 * Reads CASLocalCacheFile from the configuration file.
 */
static const char *read_CASLocalCacheFile(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLocalCacheFile = (char *) word;
    return NULL;
}

/*
 * Reads CASLogoutParameter from the configuration file.
 */
static const char *read_CASLogoutParameter(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLogoutParameter = (char *) word;
    return NULL;
}

/*
 * Reads CASLogoutLocalURL from the configuration file.
 */
static const char *read_CASLogoutLocalURL(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLogoutLocalURL = (char *) word;
    return NULL;
}

/*
 * Reads CASEGDFile from the configuration file.
 */
static const char *read_CASEGDFile(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASEGDFile = (char *) word;
    return NULL;
}

/*
 * Reads CASLocalCacheSize from the configuration file.
 */
static const char *read_CASLocalCacheSize(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLocalCacheSize = atoi(word);
    if (c->CASLocalCacheSize <= 0)
	return "CASLocalCacheSize must be a positive number";
    return NULL;
}

/*
 * Reads CASDEBUG from the configuration file.
 */
static const char *read_CASDEBUG(
	cmd_parms *cmd, void *dummy, int bool) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASDEBUG = (!(!bool));
    cas_debug = c->CASDEBUG ;
    return NULL;
}

/*
 * Reads CASLocalCacheTimeout from the configuration file.
 */
static const char *read_CASLocalCacheTimeout(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLocalCacheTimeout = atoi(word);
    if (c->CASLocalCacheTimeout <= 0)
	return "CASLocalCacheTimeout must be a positive number";
    return NULL;
}

/*
 * Reads CASLocalCacheInsecure from the configuration file.
 */
static const char *read_CASLocalCacheInsecure(
	cmd_parms *cmd, void *dummy, int bool) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLocalCacheInsecure = (!(!bool));
    return NULL;
}

/*
 * Reads CASTrustedCA from the configuration file.
 */
static const char *read_CASTrustedCA(
	cmd_parms *cmd, void *dummy, const char *words) {
  static int i = 0 ;
  static char **trusted_ca = NULL ;
  static char **before_trusted_ca = NULL ;
  int	n ; 

    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);

    if (strlen(words) > 0) {
      if (i == 0) {
	trusted_ca = (char **)malloc(sizeof(char *)*2) ;
	trusted_ca[0] = (char *)malloc(sizeof(char)*(strlen(words)+2)) ;
	for(n = 0; *(words+n) != 0;n++) trusted_ca[0][n] = words[n] ; trusted_ca[0][n] = 0 ;
	trusted_ca[1] = NULL ;
      }
      else {
	before_trusted_ca = trusted_ca ;
	trusted_ca = (char **)malloc(sizeof(char *)*(i+2)) ;

	for(n = 0; n < i+1; n++) {
	  trusted_ca[n] = before_trusted_ca[n] ;
	}

	trusted_ca[i] = (char *)malloc(sizeof(char)*(strlen(words)+2)) ;

	for(n = 0; *(words+n) != 0;n++) trusted_ca[i][n] = words[n] ; trusted_ca[i][n] = 0 ;
	trusted_ca[i+1] = NULL ;
	free((char **)before_trusted_ca) ;
      }

      i += 1 ;
    }

    c->CASTrustedCA = trusted_ca ;
    return NULL;
}

/*
 * Reads CASTrustedCADir from the configuration file.
 */
static const char *read_CASTrustedCADir(
	cmd_parms *cmd, void *dummy, const char *words) {
  static int i = 0 ;
  static char **trusted_ca_dir = NULL ;
  static char **before_trusted_ca_dir = NULL ;
  int	n ; 

    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);

    if (strlen(words) > 0) {
      if (i == 0) {
	trusted_ca_dir = (char **)malloc(sizeof(char *)*2) ;
	trusted_ca_dir[0] = (char *)malloc(sizeof(char)*(strlen(words)+2)) ;
	for(n = 0; *(words+n) != 0;n++) trusted_ca_dir[0][n] = words[n] ; trusted_ca_dir[0][n] = 0 ;
	trusted_ca_dir[1] = NULL ;
      }
      else {
	before_trusted_ca_dir = trusted_ca_dir ;
	trusted_ca_dir = (char **)malloc(sizeof(char *)*(i+2)) ;

	for(n = 0; n < i+1; n++) {
	  trusted_ca_dir[n] = before_trusted_ca_dir[n] ;
	}

	trusted_ca_dir[i] = (char *)malloc(sizeof(char)*(strlen(words)+2)) ;

	for(n = 0; *(words+n) != 0;n++) trusted_ca_dir[i][n] = words[n] ; trusted_ca_dir[i][n] = 0 ;
	trusted_ca_dir[i+1] = NULL ;
	free((char **)before_trusted_ca_dir) ;
      }

      i += 1 ;
    }

    c->CASTrustedCADir = trusted_ca_dir ;
    return NULL;
}

/*
 * Reads CASLOGFILE from the configuration file.
 */
static const char *read_CASLOGFILE(
	cmd_parms *cmd, void *dummy, const char *word) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_get_module_config(
	cmd->server->module_config, &cas2_module);
    c->CASLOGFILE = (char *) word;
    cas_logfile = c->CASLOGFILE ;
    return NULL;
}

/*
 * Returns a newly allocated server configuration record, filled in with the
 * default values.  Since we provide no "merge" routine, we expect that
 * more specific settings will occlude less specific settings.  This may
 * be important -- for instance, if there is a virtual server configured
 * for SSL support on a server that is otherwise unprotected.
 */
#ifdef	APACHE1
static void *init_server_config(pool *p, server_rec *s) {
    mod_cas2_conf *c = (mod_cas2_conf *) ap_pcalloc(p, sizeof(mod_cas2_conf));
#else	/* APACHE2 */
static void *init_server_config(apr_pool_t *p, server_rec *s) {
    mod_cas2_conf *c = apr_pcalloc(p, sizeof(mod_cas2_conf));
#endif	
    c->CASLocalCacheFile = DEFAULT_CASLocalCacheFile;
    c->CASLocalCacheSize = DEFAULT_CASLocalCacheSize;
    c->CASLocalCacheTimeout = DEFAULT_CASLocalCacheTimeout;
    c->CASLocalCacheInsecure = DEFAULT_CASLocalCacheInsecure;
    c->CASLogoutParameter = DEFAULT_CASLogoutParameter;
    c->CASLogoutLocalURL = DEFAULT_CASLogoutLocalURL;
    c->CASHost           = DEFAULT_CASHost ;
    c->CASPort           = DEFAULT_CASPort ;
    c->CASValidatePort   = DEFAULT_CASValidatePort ;
    c->CASMethod         = DEFAULT_CASMethod ;
    c->CASLogin          = DEFAULT_CASLogin ;
    c->CASLogout         = DEFAULT_CASLogout ;
    c->CASGoback         = DEFAULT_CASGoback ;
    c->CASLoginSSL       = DEFAULT_CASLoginSSL ;
    c->CASLogoutSSL      = DEFAULT_CASLogoutSSL ;
    c->CASValidateSSL    = DEFAULT_CASValidateSSL ;
    c->CASGobackSSL      = DEFAULT_CASGobackSSL ;
    c->CASDEBUG          = DEFAULT_CASDEBUG ;
    c->CASValidate       = DEFAULT_CASValidate ;
    c->CASProtocol       = DEFAULT_CASProtocol ;
    c->CASTrustedCA      = NULL ;
    c->CASTrustedCADir   = NULL ;
    c->CASLOGFILE        = DEFAULT_CASLOGFILE ;
    return c;
}

